commit 76aaf6e3617d8b8a96cc7e3194d7541d38366187
Author: Michael Moll <kvedulv@kvedulv.de>
Date:   Thu Sep 3 11:01:29 2015 +0200

    add highline to dependencies for trusty
    
    1.6.21 is required for kafo 0.6.12.

diff --git a/dependencies/trusty/highline/changelog b/dependencies/trusty/highline/changelog
new file mode 100644
index 000000000..b61e00673
--- /dev/null
+++ b/dependencies/trusty/highline/changelog
@@ -0,0 +1,135 @@
+ruby-highline (1.6.21-1) precise; urgency=low
+
+  * Improved Windows integration (by Ronie Henrich).
+  * Clarified menu choice error messages (by Keith Bennett).
+  * Fixed a bug with FFI::NCurses integration (by agentdave).
+  * Improved StringExtensions performance (by John Leach).
+  * Various JRuby fixes (by presidentbeef).
+
+ -- Marek Hulan <mhulan@redhat.com>  Mon, 10 Mar 2014 09:49:42 +0000
+
+ruby-highline (1.6.19-1) unstable; urgency=low
+
+  [ Prach Pongpanich ]
+  * Imported Upstream version 1.6.19
+  * Bump Standards-Version to 3.9.4 (no changes needed)
+  * Drop transitional binary packages
+
+  [ Cédric Boutillier ]
+  * debian/control:
+    + remove obsolete DM-Upload-Allowed flag
+    + use canonical URI in Vcs-* fields
+    + improve description
+    + update my email address
+  * set external encoding when needed for tests
+  * update my email address and years in debian/copyright
+  * remove lintian-overrides, about transitional packages
+  * add disable_test_terminal_size.patch: disable a failing test with
+    pbuilder/sbuild.
+
+ -- Cédric Boutillier <boutil@debian.org>  Fri, 28 Jun 2013 08:20:32 +0200
+
+ruby-highline (1.6.13-2) unstable; urgency=low
+
+  * Added myself to uploaders.
+  * Build depend on gem2deb >= 0.3.0.
+  * debian/copyright: change reference from common-licenses symlink LPGL to
+    LGPL-2.1.
+    - Fix lintian warning.
+
+ -- Per Andersson <avtobiff@gmail.com>  Tue, 26 Jun 2012 00:18:32 +0200
+
+ruby-highline (1.6.13-1) unstable; urgency=low
+
+  * New upstream version
+  * Drop patches (merged upstream)
+
+ -- Cédric Boutillier <cedric.boutillier@gmail.com>  Thu, 21 Jun 2012 00:05:09 +0200
+
+ruby-highline (1.6.12-1) unstable; urgency=low
+
+  * New upstream version
+  * Add myself to Uploaders:
+  * Bump Standards-Version: to 3.9.3 (no changes needed)
+  * Use Breaks instead of Conflicts for transitional packages
+  * Set Priority of transitional packages to extra
+  * Convert copyright file to DEP-5
+  * Override lintian warning about duplicate description for transitional
+    packages
+  * debian/patches:
+    + update remove-shebangs.patch to include new files
+    + add change-shebangs-in-examples.patch fixing shebangs in examples
+
+ -- Cédric Boutillier <cedric.boutillier@gmail.com>  Wed, 16 May 2012 15:09:24 +0200
+
+ruby-highline (1.6.2-1) unstable; urgency=low
+
+  * New upstream version.
+  * Switch to gem2deb-based packaging.
+
+ -- Lucas Nussbaum <lucas@debian.org>  Sun, 05 Jun 2011 09:27:01 +0200
+
+libhighline-ruby (1.5.2-1) unstable; urgency=low
+
+  [ Ryan Niebur ]
+  * set myself as Maintainer
+
+  [ Paul van Tilburg ]
+  * New upstream release. 
+  * Added support for Ruby 1.9.1.
+  * debian/control:
+    - Bumped standards version to 3.8.4.
+    - Bumped debhelper build-depend to >= 5.
+    - Added a libhighline-ruby1.9.1 package entry.
+    - Added a build depend on ruby1.9.1.
+
+ -- Paul van Tilburg <paulvt@debian.org>  Sun, 14 Feb 2010 17:51:37 +0100
+
+libhighline-ruby (1.5.1-1) unstable; urgency=low
+
+  * New upstream release
+  * add myself to uploaders
+  * refresh patches
+  * add Homepage field
+  * add README.source
+
+ -- Ryan Niebur <ryanryan52@gmail.com>  Sun, 10 May 2009 12:11:54 -0700
+
+libhighline-ruby (1.5.0-1) unstable; urgency=low
+
+  [ Gunnar Wolf ]
+  * Changed section to Ruby as per ftp-masters' request
+
+  [ Paul van Tilburg ]
+  * New upstream release.
+  * debian/control:
+    - Bumped the standards version to 3.8.1. 
+    - Added a depend on ${misc:Depends} to libhighline-ruby{,-doc,.1.8}.
+  * debian/compat: bumped compatibility to version 5.
+  * debian/copyright: converted to the UTF-8 charset. 
+  * debian/patches: updated 01_fix-shebang.patch. 
+
+ -- Paul van Tilburg <paulvt@debian.org>  Tue, 05 May 2009 19:47:17 +0200
+
+libhighline-ruby (1.4.0-1) unstable; urgency=low
+
+  * New upstream release.
+  * Adapted debian/control, debian/rules, and remove debian/control.in to
+    drop the Uploaders rule.
+  * Added myself to the Uploaders field.
+
+ -- Paul van Tilburg <paulvt@debian.org>  Tue, 19 Jun 2007 11:05:20 +0100
+
+libhighline-ruby (1.2.2-1) unstable; urgency=low
+
+  * New upstream release
+  * Patch yet another file (new in this release) to have the correct ruby path
+  * Add "ruby1.8" to libhighline-ruby1.8 Depends:
+
+ -- Esteban Manchado Velázquez <zoso@debian.org>  Sat, 21 Oct 2006 20:37:12 +0100
+
+libhighline-ruby (1.2.0-1) unstable; urgency=low
+
+  * First upload (Closes: #372530).
+
+ -- Esteban Manchado Velázquez <zoso@debian.org>  Sat, 10 Jun 2006 15:23:13 +0100
diff --git a/dependencies/trusty/highline/compat b/dependencies/trusty/highline/compat
new file mode 100644
index 000000000..7f8f011eb
--- /dev/null
+++ b/dependencies/trusty/highline/compat
@@ -0,0 +1 @@
+7
diff --git a/dependencies/trusty/highline/control b/dependencies/trusty/highline/control
new file mode 100644
index 000000000..e6eeedd45
--- /dev/null
+++ b/dependencies/trusty/highline/control
@@ -0,0 +1,21 @@
+Source: ruby-highline
+Section: ruby
+Priority: optional
+Maintainer: Debian Ruby Extras Maintainers <pkg-ruby-extras-maintainers@lists.alioth.debian.org>
+Uploaders: Lucas Nussbaum <lucas@debian.org>, Cédric Boutillier <boutil@debian.org>, Per Andersson <avtobiff@gmail.com>
+Build-Depends: debhelper (>= 7.0.50~), gem2deb (>= 0.3.0~)
+Standards-Version: 3.9.4
+Vcs-Git: git://anonscm.debian.org/pkg-ruby-extras/ruby-highline.git
+Vcs-Browser: http://anonscm.debian.org/gitweb?p=pkg-ruby-extras/ruby-highline.git;a=summary
+Homepage: http://highline.rubyforge.org
+XS-Ruby-Versions: all
+
+Package: ruby-highline
+Architecture: all
+XB-Ruby-Versions: ${ruby:Versions}
+Depends: ${shlibs:Depends}, ${misc:Depends}, ruby | ruby-interpreter
+Description: high-level interactive IO Ruby library
+ Highline is a high-level IO library that provides validation, type conversion,
+ and more for command-line interfaces. It also includes a complete menu system
+ that can crank out anything from simple list selection to complete shells with
+ just minutes of work.
diff --git a/dependencies/trusty/highline/copyright b/dependencies/trusty/highline/copyright
new file mode 100644
index 000000000..7855d9ddf
--- /dev/null
+++ b/dependencies/trusty/highline/copyright
@@ -0,0 +1,112 @@
+Format: http://www.debian.org/doc/packaging-manuals/copyright-format/1.0/
+Upstream-Name: highline
+Source: http://rubyforge.org/frs/?group_id=683
+
+Files: *
+Copyright: 2005-2011 James Edward Gray II <james@grayproductions.net>
+           2005-2011 Greg Brown <gregory.t.brown@gmail.com> 
+License: GPL-2 or Ruby
+
+Files: setup.rb
+Copyright: 2000-2004 Minero Aoki
+License: LGPL-2.1
+
+Files: debian/*
+Copyright: 2011-2012 Lucas Nussbaum <lucas@debian.org>
+           2012-2013 Cédric Boutillier <boutil@debian.org>
+License: GPL-2 or Ruby
+
+License: GPL-2
+ This program is free software; you can redistribute it and/or modify
+ it under the terms of the GNU General Public License Version 2 as published
+ by the Free Software Foundation.
+ .
+ This program is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ GNU General Public License for more details.
+ .
+ You should have received a copy of the GNU General Public License
+ along with this program; if not, write to the Free Software
+ Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
+ .
+ On Debian systems, the full text of the GNU General Public
+ License version 2 can be found in the file
+ `/usr/share/common-licenses/GPL-2'.
+
+License: LGPL-2.1
+ This library is free software; you can redistribute it and/or
+ modify it under the terms of the GNU Lesser General Public
+ License as published by the Free Software Foundation; either
+ version 2.1 of the License, or (at your option) any later version.
+ .
+ This library is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ Lesser General Public License for more details.
+ .
+ You should have received a copy of the GNU Lesser General Public
+ License along with this library; if not, write to the Free Software
+ Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
+ .
+ On Debian GNU/Linux systems, the complete text of the GNU Lesser General
+ Public License can be found in `/usr/share/common-licenses/LGPL-2.1'.
+
+License: Ruby
+ You can redistribute it and/or modify it under either the terms of the GPL,
+ or the conditions below:
+ .
+   1. You may make and give away verbatim copies of the source form of the
+      software without restriction, provided that you duplicate all of the
+      original copyright notices and associated disclaimers.
+ .
+   2. You may modify your copy of the software in any way, provided that
+      you do at least ONE of the following:
+ .
+        a) place your modifications in the Public Domain or otherwise
+           make them Freely Available, such as by posting said
+           modifications to Usenet or an equivalent medium, or by allowing
+           the author to include your modifications in the software.
+ .
+        b) use the modified software only within your corporation or
+           organization.
+ .
+        c) rename any non-standard executables so the names do not conflict
+           with standard executables, which must also be provided.
+ .
+        d) make other distribution arrangements with the author.
+ .
+   3. You may distribute the software in object code or executable
+      form, provided that you do at least ONE of the following:
+ .
+        a) distribute the executables and library files of the software,
+           together with instructions (in the manual page or equivalent)
+           on where to get the original distribution.
+ .
+        b) accompany the distribution with the machine-readable source of
+           the software.
+ .
+        c) give non-standard executables non-standard names, with
+           instructions on where to get the original software distribution.
+ .
+        d) make other distribution arrangements with the author.
+ .
+   4. You may modify and include the part of the software into any other
+      software (possibly commercial).  But some files in the distribution
+      are not written by the author, so that they are not under this terms.
+ .
+      They are gc.c(partly), utils.c(partly), regex.[ch], st.[ch] and some
+      files under the ./missing directory.  See each file for the copying
+      condition.
+ .
+   5. The scripts and library files supplied as input to or produced as
+      output from the software do not automatically fall under the
+      copyright of the software, but belong to whomever generated them,
+      and may be sold commercially, and may be aggregated with this
+      software.
+ .
+   6. THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
+      IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
+      WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+      PURPOSE.
+
diff --git a/dependencies/trusty/highline/patches/disable_test_terminal_size.patch b/dependencies/trusty/highline/patches/disable_test_terminal_size.patch
new file mode 100644
index 000000000..9e95b5e71
--- /dev/null
+++ b/dependencies/trusty/highline/patches/disable_test_terminal_size.patch
@@ -0,0 +1,18 @@
+Description: disable test_terminal_size
+ In pbuilder/sbuild, stty size returns an empty string and thus :terminal_size
+ returns nil values. This test is thus failing.
+Origin: vendor
+Author: Cédric Boutillier <boutil@debian.org>
+Bug: https://github.com/JEG2/highline/issues/85
+Last-Update: 2013-06-28
+--- a/test/tc_highline.rb
++++ b/test/tc_highline.rb
+@@ -929,7 +929,7 @@
+     assert_equal("\e[32mThis will have a newline.\e[0m\n", @output.string)
+   end
+ 
+-  def test_terminal_size
++  def _test_terminal_size
+     assert_instance_of(Fixnum, @terminal.terminal_size[0])
+     assert_instance_of(Fixnum, @terminal.terminal_size[1])
+   end
diff --git a/dependencies/trusty/highline/patches/series b/dependencies/trusty/highline/patches/series
new file mode 100644
index 000000000..4273b90ef
--- /dev/null
+++ b/dependencies/trusty/highline/patches/series
@@ -0,0 +1 @@
+disable_test_terminal_size.patch
diff --git a/dependencies/trusty/highline/ruby-highline.docs b/dependencies/trusty/highline/ruby-highline.docs
new file mode 100644
index 000000000..e475c53ed
--- /dev/null
+++ b/dependencies/trusty/highline/ruby-highline.docs
@@ -0,0 +1 @@
+README.rdoc
diff --git a/dependencies/trusty/highline/ruby-tests.rb b/dependencies/trusty/highline/ruby-tests.rb
new file mode 100644
index 000000000..29713205f
--- /dev/null
+++ b/dependencies/trusty/highline/ruby-tests.rb
@@ -0,0 +1,6 @@
+if defined? Encoding
+  Encoding.default_external = Encoding::UTF_8
+end
+
+$: << 'lib' << 'test' << '.'
+Dir['{spec,test}/**/{test,tc}_*.rb'].each { |f| require f }
diff --git a/dependencies/trusty/highline/rules b/dependencies/trusty/highline/rules
new file mode 100755
index 000000000..a5e7dc880
--- /dev/null
+++ b/dependencies/trusty/highline/rules
@@ -0,0 +1,15 @@
+#!/usr/bin/make -f
+#export DH_VERBOSE=1
+#
+# Uncomment to ignore all test failures (but the tests will run anyway)
+#export DH_RUBY_IGNORE_TESTS=all
+#
+# Uncomment to ignore some test failures (but the tests will run anyway).
+# Valid values:
+#export DH_RUBY_IGNORE_TESTS=ruby1.8 ruby1.9.1 require-rubygems
+#
+# If you need to specify the .gemspec (eg there is more than one)
+#export DH_RUBY_GEMSPEC=gem.gemspec
+
+%:
+	dh $@ --buildsystem=ruby --with ruby
diff --git a/dependencies/trusty/highline/source/format b/dependencies/trusty/highline/source/format
new file mode 100644
index 000000000..163aaf8d8
--- /dev/null
+++ b/dependencies/trusty/highline/source/format
@@ -0,0 +1 @@
+3.0 (quilt)
diff --git a/dependencies/trusty/highline/source/options b/dependencies/trusty/highline/source/options
new file mode 100644
index 000000000..4aceb10e3
--- /dev/null
+++ b/dependencies/trusty/highline/source/options
@@ -0,0 +1 @@
+unapply-patches
diff --git a/dependencies/trusty/highline/watch b/dependencies/trusty/highline/watch
new file mode 100644
index 000000000..6d997bb9f
--- /dev/null
+++ b/dependencies/trusty/highline/watch
@@ -0,0 +1,2 @@
+version=3
+http://pkg-ruby-extras.alioth.debian.org/cgi-bin/gemwatch/highline .*/highline-(.*).tar.gz