commit 84a016333540d5db0178f37f9167f491c132d9b3
Author: Dominic Cleal <dcleal@redhat.com>
Date:   Tue May 20 20:14:40 2014 +0100

    Add gridster-rails

diff --git a/rel-eng/releasers.conf b/rel-eng/releasers.conf
index 9eb7820ec..f54bd47cb 100644
--- a/rel-eng/releasers.conf
+++ b/rel-eng/releasers.conf
@@ -1,11 +1,11 @@
 [koji-foreman]
 releaser = tito.release.KojiReleaser
-autobuild_tags = foreman-nightly-nonscl-rhel6 foreman-nightly-nonscl-rhel7 foreman-nightly-rhel6 foreman-nightly-fedora19
+autobuild_tags = foreman-nightly-nonscl-rhel6 foreman-nightly-nonscl-rhel7 foreman-nightly-fedora19 foreman-nightly-rhel6
 
 # Requires tito 0.5.6
 [koji-foreman-nightly]
 releaser = tito.release.KojiReleaser
-autobuild_tags = foreman-nightly-nonscl-rhel6 foreman-nightly-nonscl-rhel7 foreman-nightly-rhel6 foreman-nightly-fedora19
+autobuild_tags = foreman-nightly-nonscl-rhel6 foreman-nightly-nonscl-rhel7 foreman-nightly-fedora19 foreman-nightly-rhel6
 builder = tito.builder.FetchBuilder
 builder.jenkins_url = http://ci.theforeman.org
 
diff --git a/rel-eng/tito.props b/rel-eng/tito.props
index ce7f83d59..9a2bddef0 100644
--- a/rel-eng/tito.props
+++ b/rel-eng/tito.props
@@ -100,6 +100,7 @@ whitelist = rubygem-apipie-rails
   rubygem-gettext_i18n_rails
   rubygem-gettext_i18n_rails_js
   rubygem-google-api-client
+  rubygem-gridster-rails
   rubygem-hammer_cli
   rubygem-hammer_cli_foreman
   rubygem-hashie
diff --git a/rubygem-gridster-rails/gridster-rails-0.1.5.gem b/rubygem-gridster-rails/gridster-rails-0.1.5.gem
new file mode 120000
index 000000000..2194f2bfa
--- /dev/null
+++ b/rubygem-gridster-rails/gridster-rails-0.1.5.gem
@@ -0,0 +1 @@
+../.git/annex/objects/mG/w6/SHA256E-s27648--6b35726dfd02b7ff9a8d0a10c55a812673966048c21cefc92c3a587429ca2bc6.5.gem/SHA256E-s27648--6b35726dfd02b7ff9a8d0a10c55a812673966048c21cefc92c3a587429ca2bc6.5.gem
\ No newline at end of file
diff --git a/rubygem-gridster-rails/rubygem-gridster-rails.spec b/rubygem-gridster-rails/rubygem-gridster-rails.spec
new file mode 100644
index 000000000..7c86dbf0e
--- /dev/null
+++ b/rubygem-gridster-rails/rubygem-gridster-rails.spec
@@ -0,0 +1,80 @@
+%{?scl:%scl_package rubygem-%{gem_name}}
+%{!?scl:%global pkgname %{name}}
+
+%define gem_name gridster-rails
+%global rubyabi 1.9.1
+
+Summary: This gem provides jquery.gridster.js and jquery.gridster.css for your Rails 3 application
+Name: %{?scl_prefix}rubygem-%{gem_name}
+Version: 0.1.5
+Release: 1%{?dist}
+Group: Development/Languages
+License: MIT
+URL: https://github.com/vanetten/gridster-rails
+Source0: http://rubygems.org/gems/%{gem_name}-%{version}.gem
+
+%if 0%{?fedora} > 18 || 0%{?rhel} >= 7
+Requires: %{?scl_prefix}ruby(release)
+%else
+Requires: %{?scl_prefix}ruby(abi) = %{rubyabi}
+%endif
+Requires: %{?scl_prefix}ruby(rubygems)
+Requires: %{?scl_prefix}ruby
+Requires: %{?scl_prefix}rubygem(railties) >= 3.1.0
+Requires: %{?scl_prefix}rubygem(railties) < 4.0.0
+%if 0%{?fedora} > 18 || 0%{?rhel} >= 7
+BuildRequires: %{?scl_prefix}ruby(release)
+%else
+BuildRequires: %{?scl_prefix}ruby(abi) = %{rubyabi}
+%endif
+BuildRequires: %{?scl_prefix}rubygems-devel
+BuildRequires: %{?scl_prefix}ruby
+BuildArch: noarch
+Provides: %{?scl_prefix}rubygem(%{gem_name}) = %{version}
+
+%description
+Gridster is a jQuery plugin that makes building intuitive draggable layouts
+from elements spanning multiple columns. You can even dynamically add and
+remove elements from the grid.
+
+%package doc
+Summary: Documentation for %{name}
+Group: Documentation
+Requires: %{?scl_prefix}%{pkgname} = %{version}-%{release}
+BuildArch: noarch
+
+%description doc
+Documentation for %{name}
+
+
+%prep
+%setup -q -c -T
+mkdir -p .%{gem_dir}
+%{?scl:scl enable %{scl} "}
+gem install --local --install-dir .%{gem_dir} \
+            --force %{SOURCE0}
+%{?scl:"}
+
+%build
+
+%install
+mkdir -p %{buildroot}%{gem_dir}
+cp -pa .%{gem_dir}/* \
+        %{buildroot}%{gem_dir}/
+
+
+%files
+%dir %{gem_instdir}
+%{gem_instdir}/lib
+%{gem_instdir}/vendor
+%exclude %{gem_cache}
+%exclude %{gem_instdir}/.*
+%{gem_spec}
+%doc %{gem_instdir}/LICENSE
+
+%files doc
+%doc %{gem_dir}/doc/%{gem_name}-%{version}
+%doc %{gem_instdir}/LICENSE
+%doc %{gem_instdir}/README.md
+
+%changelog